/*
*
* Galaxytool Javascripts
* (c) 2005-2007 Christian Lehmann
* mail: webmaster@mathe-informatik.de
* www: http://www.galaxytool.eu
*
* Requires: common_scripts.js
*
*/

/*
* Content for Ajax - reloading of required information and making entries visible
*/

var mouse_x = 0;
var mouse_y = 0;
var mouse_down = false;

var content_open = false;
var content_buffer = new Array();
var hide_unhide_buffer = new Array();
var temp_object = "";
var value_help_object = "";
var source_url = "";
var current_object = "";
var current_object_cached = true;
var start_time = 0;
var active; // object for timer
var timeout_start_mouse_x;
var timeout_start_mouse_y;

var docElement =  ( typeof document.compatMode != "undefined" &&  document.compatMode != "BackCompat") ? "documentElement" : "body";

/*
* Start event handler to have mouse coordinates
*/
function Init() {
	document.onmousemove =	set_mouse_pos;
	document.onclick     =	MouseReleased;
	document.onmousedown =	MousePressed;
}

/*
* This method will be called every time the mouse pos changes
*/
function set_mouse_pos(e) {
	var mouse_old_x = mouse_x;
	var mouse_old_y = mouse_y;

	mouse_x = (document.all) ? window.event.x + document.body.scrollLeft : e.pageX;
	mouse_y = (document.all) ? window.event.y + document.body.scrollTop  : e.pageY;

	// check if window shall be moved
	if (current_object != "" && mouse_down == true) {
		// check if mouse is inside our current object that shall be moved
		var move_x = mouse_x - mouse_old_x;
		var move_y = mouse_y - mouse_old_y;
		document.getElementById(current_object).style.top     = document.getElementById(current_object).offsetTop  + move_y;
		document.getElementById(current_object).style.left    = document.getElementById(current_object).offsetLeft + move_x;

		return;
	}
	
	// check if mouse_x and mouse_y are still bound, otherwise close opened object
	if (current_object != "" && current_object_cached == true) {
		var top_left_x = document.getElementById(current_object).offsetLeft;
		var top_left_y = document.getElementById(current_object).offsetTop;
		var lower_right_x = document.getElementById(current_object).offsetLeft + document.getElementById(current_object).offsetWidth;
		var lower_right_y = document.getElementById(current_object).offsetTop + document.getElementById(current_object).offsetHeight;

		// check for - 30 from the left and top to the end of the element
		if ( mouse_x < top_left_x - 30 || mouse_x > lower_right_x +30 ||
		mouse_y < top_left_y - 30 || mouse_y > lower_right_y + 30 ) {
			removeObjects();
		}
	}
}

/*
* This method stores all required information and calls the updateObjects() method
* after 500 milliseconds timeout.
*/
function ShowObject(param_object,param_url,caching) {
	source_url = param_url;
	temp_object = param_object;
	timeout_start_mouse_x = mouse_x;
	timeout_start_mouse_y = mouse_y;
	window.clearTimeout(active);
	if (caching == true) {
		current_object_cached = true;
		active = setTimeout("updateObjects('true')",500);
	} else {
		current_object_cached = false;
		active = setTimeout("updateObjects('false')",500);
	}
}

function ShowValueHelp(param_object,param_url,source_object) {
	source_url = param_url;
	value_help_object = param_object;
	window.clearTimeout(active);
	active = setTimeout("updateValueHelp('"+source_object+"')",500);
}

/*
* If the mouse is still in valid range (+-20 px of mouseoverpos)
* check if the content was loaded before and make it visible again
* otherwise load the content and make it visible
*/
function updateObjects(caching) {
	// if object is already opened, quit
	if (content_open == true && caching == true) {
		return;
	}
	window.clearTimeout(active);

	removeObjects();

	// check if mouse was moved during timeout
	if (caching == true && (mouse_x < timeout_start_mouse_x - 20 || mouse_x > timeout_start_mouse_x + 20 ||
	mouse_y < timeout_start_mouse_y - 20 || mouse_y > timeout_start_mouse_y + 20 )) {
		return;
	}

	// determine position of object
	// check if content was already loaded
	if (caching == true) {
		for (var i=0; i< content_buffer.length; i++) {
			if (content_buffer[i] == temp_object) {
				document.getElementById(temp_object).style.display = "inline";
				if (mouse_y > document.getElementById(temp_object).offsetHeight) {
					document.getElementById(temp_object).style.top     = mouse_y-10- document.getElementById(temp_object).offsetHeight;
				} else {
					document.getElementById(temp_object).style.top     = mouse_y+10;
				}
				if (mouse_x > document.getElementById(temp_object).offsetWidth) {
					document.getElementById(temp_object).style.left    = mouse_x - 10 - document.getElementById(temp_object).offsetWidth;
				} else {
					document.getElementById(temp_object).style.left    = mouse_x + 10;
				}
				current_object = temp_object;
				return;
			}
		}
	}

	document.getElementById("loading").style.display = "inline";
	document.getElementById("loading").style.top     = mouse_y+10;
	document.getElementById("loading").style.left    = mouse_x+10;
	advAJAX.get({
		url : source_url,
		onSuccess : function(obj) {
			document.getElementById(temp_object).innerHTML     = obj.responseText;
			document.getElementById("loading").style.display   = "none";
			document.getElementById(temp_object).style.display = "inline";
			if (mouse_y > document.getElementById(temp_object).offsetHeight) {
				document.getElementById(temp_object).style.top     = mouse_y-10- document.getElementById(temp_object).offsetHeight;
			} else {
				document.getElementById(temp_object).style.top     = mouse_y+10;
			}
			if (mouse_x > document.getElementById(temp_object).offsetWidth) {
				document.getElementById(temp_object).style.left    = mouse_x - 10 - document.getElementById(temp_object).offsetWidth;
			} else {
				document.getElementById(temp_object).style.left    = mouse_x + 10;
			}
			content_open = true;
			if (caching == true) {
				content_buffer.push(temp_object);
			}
			current_object = temp_object;
		},
		onError : function(obj) { alert("Error: " + obj.status); }
	});
}

function updateValueHelp(source_object) {
	window.clearTimeout(active);
	removeObjects();

	// determine position of object
	document.getElementById(value_help_object).style.left = getAbsolutePosition(document.getElementById(source_object)).x;
	document.getElementById(value_help_object).style.top  = getAbsolutePosition(document.getElementById(source_object)).y + document.getElementById(source_object).offsetHeight;

	advAJAX.get({
		url : source_url,
		onSuccess : function(obj) {
			document.getElementById(value_help_object).innerHTML     = obj.responseText;
			document.getElementById(value_help_object).style.display = "inline";
		},
		onError : function(obj) { alert("Error: " + obj.status); }
	});
}

/*
* set diplay: none to all possible objects
*/
function removeObjects() {
	// remove all objects from buffer
	for (var i=0; i< content_buffer.length; i++) {
		document.getElementById(content_buffer[i]).style.display = "none";
	}
	// remove other possible objects which are not buffered - like popup
	if (current_object != "") {
		document.getElementById(current_object).style.display = "none";
	}
	if (value_help_object != "") {
		document.getElementById(value_help_object).style.display = "none";
	}
	content_open = false;
}

/*
* request the request_url and ask the confirm dialog if requested
*/
function requestPage(request_url, with_request_dialog, request_dialog) {
	if ((with_request_dialog == true && confirm(request_dialog)) || (with_request_dialog == false)) {
		// request page
		advAJAX.get({
			url : request_url,
			onSuccess : function(obj) {
				if (obj.responseText == "true") {
					removeObjects();
					return true;
				} else {
					alert("Fehler: "+obj.responseText);
					removeObjects();
					return false;
				}
			},
			onError : function(obj) {
				removeObjects();
				alert("Error: " + obj.status);
				return false;
			}
		});
	}
}

function changePlayerStats(request_url, with_request_dialog, request_dialog, span_id, css_classname) {
	if (requestPage(request_url, with_request_dialog, request_dialog) == false) {
		return;
	}
	try {
		document.getElementById("pr_"+span_id).setAttribute('class',"bg_"+css_classname);
	} catch(e) { /* alert("error1: "+e);  - no error message here! used at playerinformation.php without background color */ }
	try {
		document.getElementById("pn_"+span_id).setAttribute('class',css_classname);
	} catch(e) { alert("error2: "+e); }
}


function setValueHelpContent(current_object, new_value) {
	document.getElementById(current_object).value = new_value;
	removeObjects();
}

function MousePressed() {
	// check if we have an object
	if (current_object != "") {
		var top_left_x = document.getElementById(current_object).offsetLeft;
		var top_left_y = document.getElementById(current_object).offsetTop;
		var lower_right_x = document.getElementById(current_object).offsetLeft + document.getElementById(current_object).offsetWidth;
		var lower_right_y = document.getElementById(current_object).offsetTop + document.getElementById(current_object).offsetHeight;

		// check is mouse is inside our current object that shall be moved
		if ( mouse_x > top_left_x && mouse_x < lower_right_x && mouse_y > top_left_y && mouse_y < lower_right_y ) {
			mouse_down = true;
		}
	}
}

function MouseReleased() {
	mouse_down = false;
}